var templates = require("masm-template");
var utils     = require("masm-util");

var proc = function(obj, callback) {
    console.log("MAILER STUB> Sending email:");
    console.log("MAILER STUB> " + JSON.stringify(obj));
    callback(false);
};

module.exports = function() {
    return {
        send : function (obj, callback) {
            if (!obj.to) { utils.exitWithError("email conf does not have a recipient"); }
            if (!obj.subject) { utils.exitWithError("email conf does not have a subject"); }
            if (!(obj.body || (obj.template && obj.data))) { utils.exitWithError("email conf does not have a body"); }

            if (obj.body) {
                return proc(obj, callback );
            } else {
                return templates.afterLoadingTemplate(obj, function (obj) {
                    proc(obj, callback);
                });
            }
        }
    };
};
